

             REVISION -commun "-- Basic communication 0.5K ERROR is 0 ---"

\ Change : ERROR starts on zero, some unused/commented out code removed.

\ #################### communication ###########################################

\ The communication has to be used before the down system has booted.
\ So it must not use FWORD's, that may map onto the boot program
\ Naming convention: picture of machines: pc->root->tn-> tn-1-> ... t0
\ The -> in the word gives the direction in this picture.
\ The first letter is data type: $ M W D
\ The second letter is S(end) or R(ecieve)

\ The following link/channels are all that is used
CHANNEL, COMM->COMP      \ Link between Communication and Computing
CHANNEL, COMM->COML      \ Link between Communication and Auxiliary Process
CHANNEL, COMM<-COMP      \ Link between Communication and Computing
LINK0-IN CONSTANT LINKUP-IN     \ Link to upper,i.e where the commands come from.
LINK0-OUT CONSTANT LINKUP-OUT   \ Corresponding output
LINK2-IN CONSTANT LINKDOWN-IN   \ Link to down, i.e where we pass commands to.
LINK2-OUT CONSTANT LINKDOWN-OUT \ Corresponding output

\ All message storage is for recieving.
\ The links may be used fro double words
0. DWORD MessageLeft  \ Temporary storage for messages from ->
0. DWORD MessageRight \ Temporary storage for messages from <-
0. DWORD MessageSync  \ Temporary storage for messages from M<-P


0 WWORD ERROR      \ Inspected by main communicator
\ This is done under such severe situations that it is dubious
\ this error will be sent. However it may be inspected by debuggers.
PROC TILT,
   -1 ldc, ERROR stl,
END-PROC

\ Input a word from a link or channel to n ( WWORD n -- )
\ tested
        \ dest         chan            count         input a word
MACRO WR->,   ldlp, LINKUP-IN ldc,    1 ldc, bcnt,  in,  END-MACRO
MACRO WR<-,   ldlp, LINKDOWN-IN ldc,    1 ldc, bcnt,  in,  END-MACRO
MACRO WRM->P, ldlp, COMM->COMP ldlp, 1 ldc, bcnt,  in,  END-MACRO
MACRO WRM<-P, ldlp, COMM<-COMP ldlp, 1 ldc, bcnt,  in,  END-MACRO
MACRO WR,    ( reg A)  ldlp, rev,    1 ldc, bcnt, in,   END-MACRO
MACRO DR,    ( reg A)  ldlp, rev,    2 ldc, bcnt, in,   END-MACRO
MACRO DRM->P, ldlp, COMM->COMP ldlp, 2 ldc, bcnt,  in,  END-MACRO

\ Output a word to a link or channel from n ( WWORD n -- )
\ tested
MACRO WS<-,   LINKUP-OUT ldc,     ( stack) ldl, outword,  END-MACRO
MACRO WS->,   LINKDOWN-OUT ldc,     ( stack) ldl, outword,  END-MACRO
MACRO WSM->P, COMM->COMP ldlp,   ( stack) ldl, outword,  END-MACRO
MACRO WSM<-P, COMM<-COMP ldlp,   ( stack) ldl, outword,  END-MACRO
MACRO WS,     ( reg A)           ( stack) ldl, outword,  END-MACRO
\ MACRO DS,    ldlp, rev,             2 ldc, bcnt, out,   END-MACRO \ untested ever needed ?

\ Input a byte from a link or channel to n ( WWORD n -- )
\ tested
        \ dest         chan            count         input a word
MACRO BR<-,   ldlp, LINKDOWN-IN ldc,    1 ldc, in,  END-MACRO

\ Output a byte to a link or channel from n ( WWORD n -- )
\ tested
MACRO BS->,   ( n) ldlp,   LINKDOWN-OUT ldc,   1 ldc,   out,   END-MACRO

\ Output the double word D from the computing to calculation ( WWORD D -- )
\ tested
MACRO DSM<-P,  ( D) ldlp,   COMM<-COMP ldlp, 2 ldc, bcnt, out,     END-MACRO

\ Output the double word D from the calculation to the computing ( WWORD D -- )
MACRO DSM->P,  ( D) ldlp,   COMM->COMP ldlp, 2 ldc, bcnt, out,     END-MACRO

\ Input a message, i.e. choke when something else arrives ( Message n -- )
\ tested
MACRO MR->,  MessageLeft  DUP WR->,  ldl, ldc, <>, IF, TILT, ENDIF, END-MACRO
MACRO MR<-,  MessageRight DUP WR<-,  ldl, ldc, <>, IF, TILT, ENDIF, END-MACRO
MACRO MRM->P, MessageSync  DUP WRM->P, ldl, ldc, <>, IF, TILT, ENDIF, END-MACRO \ tested in main
MACRO MRM<-P, MessageSync  DUP WRM<-P, ldl, ldc, <>, IF, TILT, ENDIF, END-MACRO \ tested in main

\ Output a message, ( Message n -- )
\ tested
MACRO  MS<-,  LINKUP-OUT ldc,   ( stack) ldc,   outword, END-MACRO
MACRO  MS->,  LINKDOWN-OUT ldc,   ( stack) ldc,   outword, END-MACRO
MACRO  MSM->P, COMM->COMP ldlp, ( stack) ldc,   outword, END-MACRO \ tested in task
MACRO  MSM<-P, COMM<-COMP ldlp, ( stack) ldc,   outword, END-MACRO \ tested in task

\ Receive/send W bytes from/to address A declared earlier as a HARRAY
\ In a task we need one more reg to handle ldl, ( address A, WWORD W -- )
\ Note: strings are only passed to the left: down the drain (read consumer)
\ tested outside task
MACRO $R->, SWAP ldl, IN-TASK @ IF ldl, LINKUP-IN  ldc, rev, ELSE LINKUP-IN  ldc, ldl, THEN  in, END-MACRO
MACRO $S->, SWAP ldl, IN-TASK @ IF ldl, LINKDOWN-OUT ldc, rev, ELSE LINKDOWN-OUT ldc, ldl, THEN  out, END-MACRO

\ For the following we need the address of the link via ldc,
\  because in a task ldlp, consumes an extra stack position
: COMM->COMP/ABS
   WorkSpaceStart COMM->COMP CELLS +
   ." : COMM->COMP/ABS " DUP H. CR
;

MACRO $RM->P, SWAP ldl, IN-TASK @ IF ldl, COMM->COMP/ABS ldc, rev, ELSE COMM->COMP ldlp, ldl, THEN  in, END-MACRO
MACRO $SM->P, SWAP ldl, IN-TASK @ IF ldl, COMM->COMP/ABS ldc, rev, ELSE COMM->COMP ldlp, ldl, THEN  out, END-MACRO


\ Input a double (the m.s. word second) from the link
\ tested
MACRO DR->, ( address -- )
    DUP WR->, 1+ WR->,
END-MACRO

\ Output a double (the m.s. word second) to the link ( address -- )
MACRO DS->, DUP WS->, 1+ WS->, END-MACRO
MACRO DS<-, DUP WS<-, 1+ WS<-, END-MACRO


\ #################### debugging macro's ###########################################

0 VALUE ProcessorId      \ Alias for ChainLen that identifies the processor
\ Send the debug message over the link, with register A as content

\ Send the debug message over the link, with register A as content
\ tested
0. DWORD x-debug
MACRO DEBUG,
    x-debug stl,
    IN-TASK @ IF
        %<debug MS<-,   ProcessorId WS<-,   x-debug WS<-,
    ELSE
        %<debug MSM<-P, ProcessorId WSM<-P, x-debug WSM<-P,
    THEN
END-MACRO

\ Send a double over the link, with register A as
\ m.s. content register b as l.s. content
\ Is only used for sending the starting address
\ tested in both circumstances
MACRO DEBUG2,
    x-debug dstl,
    IN-TASK @ IF
        %<showstart MS<-,   ProcessorId WS<-,   x-debug DS<-,
    ELSE
        %<showstart MSM<-P, ProcessorId WSM<-P, x-debug DSM<-P,
    THEN
END-MACRO

\ Send an error message over the link, with N as error number
\ tested
MACRO ERROR,     ( N -- )
     ( N) ldc, x-debug stl,
    IN-TASK @ IF
        %<error MS<-, ProcessorId WS<-, x-debug WS<-,
    ELSE
        %<error MSM<-P, ProcessorId WSM<-P, x-debug WSM<-P,
    THEN
END-MACRO

\ Send an error message over the link, with N as error number
MACRO ?ERROR,     ( N -- )
    ERROR ldl, IF,
        IN-TASK @ IF
            %<error MS<-, ProcessorId WS<-, ERROR WS<-,
        ELSE
            %<error MSM<-P, ProcessorId WSM<-P, ERROR WSM<-P,
        THEN
    ENDIF,
    0 ldc, ERROR stl,
END-MACRO

\ Dump a memory area from ``Area'' with length ``L''
MACRO DUMP,    ( HARRAY Area, int L -- )
    0 DO
       DUP ldl, I ldnl, DEBUG,
    LOOP
    DROP
END-MACRO

\ CheckCrc sends an error message if the crc is not okay
PRIVATES
0 WWORD Pointer1 PRIVATE
0 WWORD Pointer2 PRIVATE
0 WWORD Crc      PRIVATE

\ Calculate the CRC of area [A,B) and compare it with the CRC at B.
\ Return "the CRC was in error" in register A.
\ It cannot be used in a TASK, because it has to load to many
\ parameters at the same time.
CrcGen WWORD   WCrcGen PRIVATE  \ The crc polynomial
MACRO (CheckCrc)        ( reg A, reg B -- reg A )
    IN-TASK @ ABORT" Do not use in a TASK"
    Pointer2 stl, \ Points to crc
    Pointer1 stl, \ Points to first word

    0 ldc, Crc stl,
    BEGIN,
        WCrcGen ldl,   Crc ldl,   Pointer1 ldl, 0 ldnl,  \ 3 params
        crcword,   Crc stl,
        Pointer1 ldl, 4 adc, Pointer1 stl,
    Pointer1 ldl, Pointer2 ldl, >=, UNTIL,

    Crc ldl,    Pointer2 ldl, 0 ldnl,  <>,
END-MACRO

DEPRIVE


