\ COPYRIGHT 1996 DUTCH FORTH WORKSHOP - FILENAME : NEWBOOT.INC #1
\ LANGUAGE    : ANS Forth / Assembler
\ PROJECT     : tForth
\ DESCRIPTION : general booter for Forth assembly programs
\ CATEGORY    : Assembly source file
\ AUTHOR      : Albert van der Horst oct 1996
\ LAST CHANGE : 961118 AH Adapted to Asswrite.frt 0.3C
\ LAST CHANGE : 96.... AH ,,
\
\ Protocol : here   there
\            TID   >
\                  < size
\                  < load address
\                  < start address (no more memstart )
\                  < size bytes at load

HEX
DECIMAL
        NEEDS -asswrite
  INIT-ASSEMBLER           \ Clear the code space
  FWORD Temp               \ First word
  FWORD OLD_IPTR           \ some nonsense
  FWORD OLD_WDESC          \ "

  FWORD bootlinkin        \  link we booted from
  FWORD size              \  store size of uploaded code
  FWORD start             \  store load address of uploaded code
  FWORD entrypoint        \  Where the code loaded should start

( Word offsets from MININT )
  7 CONSTANT Link3Input      3 CONSTANT Link3Output
  6 CONSTANT Link2Input      2 CONSTANT Link2Output
  5 CONSTANT Link1Input      1 CONSTANT Link1Output
  4 CONSTANT Link0Input      0 CONSTANT Link0Output

  8 CONSTANT Event

  9 CONSTANT TptrLoc0
#10 CONSTANT TptrLoc1

{
        #10 ajw,                        \ In a booter, WsPtr at END of program!

        OLD_IPTR  stl,                  \ pop A (Iptr)
        OLD_WDESC stl,                  \ pop B (Wdesc)
        bootlinkin  stl,               \ Save boot input link address

        mint, sthf,
        mint, stlf,                     \ store queue registers

        mint, mint, Link0Output stnl,  \ note that a loop ( lend )
        mint, mint, Link1Output stnl,  \ or ELSE, can be descheduled!
        mint, mint, Link2Output stnl,
        mint, mint, Link3Output stnl,
        mint, mint, Link0Input  stnl,
        mint, mint, Link1Input  stnl,
        mint, mint, Link2Input  stnl,
        mint, mint, Link3Input  stnl,  \ reset link channels
        mint, mint, Event       stnl,  \ reset event
        mint, mint, TptrLoc0    stnl,  \ store timer queue registers
        mint, mint, TptrLoc1    stnl,

        testerr,  clrhalterr,           \ reset error flag

\ send back a the fixed TID of a T800

        -30 ldc, Temp stl,
        Temp ldlp,
        bootlinkin ldl,  $10 ldc, xor,
        1 ldc, bcnt, out,

\ Start the timer
        0 ldc,  sttimer,        \ start timer

\  load the main code file

        size    ldlp,          \ accept size and load address via link
        bootlinkin ldl,
        1 ldc, bcnt,  in,

        start    ldlp,
        bootlinkin ldl,
        1 ldc, bcnt,  in,

        entrypoint ldlp,       \ accept entrypoint location via link
        bootlinkin ldl,
        1 ldc, bcnt,  in,

        start    ldl,          \ target address
        bootlinkin ldl,          \ channel
        size    ldl,  in,

        entrypoint ldl,        \ and entrypoint
         gcall,

}
WriteBoot boot2.x
                                ( End Booter )
